#include "StdAfx.h"
#include "Camera.h"

CCamera::CCamera(void)
{
	D3DXMatrixIdentity(&m_matProj);
}

CCamera::~CCamera(void)
{
}

void CCamera::SetModPerpective(float fFovY, float fZNear, float fZFar, float fAspect)
{
	D3DXMatrixPerspectiveFovLH(&m_matProj, fFovY, fAspect, fZNear, fZFar);
}

void CCamera::SetModOrtho(float fZNear, float fZFar, float fWidth, float fHeight)
{
	D3DXMatrixOrthoLH(&m_matProj, fZNear, fZFar, fWidth, fHeight);
}

void CCamera::GetView( D3DXMATRIX* pMatOut ) const
{
	D3DXMatrixInverse(pMatOut, NULL, &GetMatrix());
}

const D3DXMATRIX CCamera::GetView() const
{
	D3DXMATRIXA16 m;
	D3DXMatrixInverse(&m, NULL, &GetMatrix());
	return m;
}

void CCamera::GetProjection( D3DXMATRIX* pMatOut ) const
{
	*pMatOut = m_matProj;
}

const D3DXMATRIX CCamera::GetProjection() const
{
	return m_matProj;
}

void CCamera::GetViewProjection( D3DXMATRIX* pMatOut ) const
{
	D3DXMatrixMultiply(pMatOut, &GetView(), &m_matProj);
}

const D3DXMATRIX CCamera::GetViewProjection() const
{
	D3DXMATRIXA16 m;
	GetViewProjection(&m);
	return m;
}
