#pragma once
#include <d3dx9.h>

class CEntity
{
private:
	CEntity* m_pParent;
	D3DXMATRIXA16 m_matrix;

public:
	CEntity(void);
	virtual ~CEntity(void);
	
	D3DXMATRIX GetParentMatrix() const;
	D3DXMATRIX GetMatrix() const;
	
	D3DXVECTOR3 GetPos() const;
	D3DXVECTOR4 GetPos4() const;
	
	void SetMatrix(const D3DXMATRIX& mat);
	void SetRotation(const D3DXMATRIX& mat);
	void SetLookAt(D3DXVECTOR3 pos, D3DXVECTOR3 target, D3DXVECTOR3 up=D3DXVECTOR3(0, 1, 0));
	void SetPos(const D3DXVECTOR3& pos);
	void SetParent(CEntity* pParent);
	D3DXVECTOR3 GetUp() const;
	D3DXVECTOR3 GetRight() const;
	D3DXVECTOR3 GetForward() const;
};
