#include "StdAfx.h"
#include "EntityModel.h"
#include "Graphics.h"

using namespace std;

CEntityModel::CEntityModel(const string& strFileName)
{
	if (strFileName.length()>0)
		SetModel(strFileName);
	else
		m_pMesh = NULL;
}

CEntityModel::~CEntityModel(void)
{
	ReleaseModel();
}

bool CEntityModel::SetModel( const string& strFileName)
{
	ReleaseModel();
	m_pMesh = Graphics::get().LoadMesh(strFileName);
	return (m_pMesh!=NULL);
}

void CEntityModel::ReleaseModel()
{
	if (m_pMesh!=NULL)
	{
		//      
		m_pMesh = NULL;
	}
}

CMeshPtr CEntityModel::GetMesh() const
{
	return m_pMesh;
}
