#include "StdAfx.h"
#include "GameApplication.h"

CGameApplication::CGameApplication()
: m_hMainWnd (0),
m_hInst(0),
m_IDI_ICON(0),
m_IDI_SMALL_ICON(0)
{
//	m_szWindowClass = L"GameWindow";
}

bool CGameApplication::Create( HINSTANCE hInstance, WORD IDI_ICON, WORD IDI_SMALL_ICON )
{
	m_hInst = hInstance;
	m_IDI_ICON = IDI_ICON;
	m_IDI_SMALL_ICON = IDI_SMALL_ICON;

	if (!MyRegisterClass())
		return false;

	if (!InitInstance(SW_SHOW))
		return false;

	if (!Init())
		return false;

	return true;
}

CGameApplication::~CGameApplication(void)
{
}

ATOM CGameApplication::MyRegisterClass(/*HINSTANCE hInstance*/)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= m_hInst;
	wcex.hIcon			= LoadIcon(m_hInst, MAKEINTRESOURCE(m_IDI_ICON));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= L"GameWnd";//m_szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(m_IDI_SMALL_ICON));

	return RegisterClassEx(&wcex);
}

BOOL CGameApplication::InitInstance(/*HINSTANCE hInstance, */int nCmdShow)
{
//	m_hInst = hInstance; // Store instance handle in our global variable

	m_hMainWnd = CreateWindow(L"GameWnd"/*m_szWindowClass*/, L"Tutorial", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, 800, 600, NULL, NULL, m_hInst, NULL);

	if (!m_hMainWnd)
	{
		return FALSE;
	}
	SetWindowLongPtr(m_hMainWnd, GWLP_USERDATA, (LONG_PTR)(this));

	ShowWindow(m_hMainWnd, nCmdShow);
	UpdateWindow(m_hMainWnd);

	return TRUE;
}

LRESULT CALLBACK CGameApplication::WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	CGameApplication* pApp = (CGameApplication*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
	
	if (!pApp) //    ,    - 
		return DefWindowProc(hWnd, message, wParam, lParam);

	switch (message)
	{
	case WM_ERASEBKGND:
		return TRUE;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			EndPaint(hWnd, &ps);

			break;
		}
	case WM_DESTROY:
		if (pApp)
			pApp->CleanUp();
		
		PostQuitMessage(0);

		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

HWND CGameApplication::GetHwnd()
{
	return m_hMainWnd;
}

int CGameApplication::Run()
{
	// Main message loop:
	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));
	while( msg.message!=WM_QUIT ) //     
	{
		// ,     
		if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
		{
			//  ,  
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else //   
		{
			float fDeltaTime = .02f; //  
			UpdateFrame(fDeltaTime);
			Render();
		}
	}
	return (int) msg.wParam;
}
