#pragma once
#include <d3d9.h>
#include <string>

struct CPoint
{
	int m_x, m_y;
	CPoint();
	CPoint(int x, int y);
};

struct CRect
{
	CPoint m_min, m_max;
	CRect();
	CRect(CPoint ptMin, CPoint ptMax);
};

template<typename ForwardIter,
typename OutputIter, typename UnaryPred>
OutputIter copy_if(ForwardIter begin, ForwardIter end,
				   OutputIter dest, UnaryPred f)
{
	while(begin != end)
	{
		if(f(*begin))
			*dest++ = *begin;
		++begin;
	}
	return dest;
}

std::string GetFileAsString(const std::string& strFileName);