#pragma once

#include "GameApplication.h"

#include <string>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <functional> 
#include <pugixml.hpp>

#include "Graphics.h"
#include "PlayerShip.h"
#include "StarField.h"
#include "Enemy.h"
#include "Bullet.h"
#include "Explosion.h"
#include "AIBase.h"
#include "GameLevel.h"

class CTutorial2D :
	public CGameApplication
{
	int m_keyLeft;
	int m_keyRight;
	int m_keyFire;

	std::vector< CExplosion* > vecExplosions;
	std::vector<CEnemy> vecEnemies;
	std::vector<CBullet> vecBulletPlayer;

	CGameLevel m_Level;

	CShaderPtr m_pPixelShader , m_pVertexShader ;

	CStarField* m_pStarField;
	CPlayerShip* m_pPlayer;

	bool LoadConfig();
	void UpdateWorld(const float fDeltaTime);
	void ProcessUserInput(float fDeltaTime);

protected:
	bool Init();
	void CleanUp();
	void Render();
	void UpdateFrame();

public:
	std::vector<CBullet> vecBulletEnemy;

	CTutorial2D(void);
	~CTutorial2D(void);
};
