#pragma once

#include "GameApplication.h"

#include <string>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <functional> 
#include <pugixml.hpp>

#include "Graphics.h"
#include "Mesh.h"
#include "EntityModel.h"
#include "Camera.h"

class CTutorial3D :
	public CGameApplication
{
	CCamera m_camera;
	CShaderPtr m_pPixelShaderPhong , m_pVertexShaderPhong ;

	CEntityModel m_modelTop, m_modelMiddle, m_modelBottom;
	CTexturePtr m_pTexDiffuse;

	void ProcessUserInput(float fDeltaTime);

protected:
	bool Init();
	void CleanUp();
	void Render();
	void UpdateFrame(float fDeltaTime);

public:
	CTutorial3D(void);
	~CTutorial3D(void);
};
